import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["threshold"],
  _excluded2 = ["threshold"],
  _excluded3 = ["threshold"],
  _excluded4 = ["threshold"],
  _excluded5 = ["value", "includeThreshold"],
  _excluded6 = ["value", "includeThreshold"],
  _excluded7 = ["message"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import { required, length, pattern, numericality } from '../validators/validator-functions';
import url from '../validators/url-validator';
import validatorTypes from '../validator-types';
var validatorMapper = _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, validatorTypes.REQUIRED, required), validatorTypes.MIN_LENGTH, function (_ref) {
  var threshold = _ref.threshold,
    rest = _objectWithoutProperties(_ref, _excluded);
  return length(_objectSpread({
    minimum: threshold
  }, rest));
}), validatorTypes.MAX_LENGTH, function (_ref2) {
  var threshold = _ref2.threshold,
    rest = _objectWithoutProperties(_ref2, _excluded2);
  return length(_objectSpread({
    maximum: threshold
  }, rest));
}), validatorTypes.EXACT_LENGTH, function (_ref3) {
  var threshold = _ref3.threshold,
    rest = _objectWithoutProperties(_ref3, _excluded3);
  return length(_objectSpread({
    is: threshold
  }, rest));
}), validatorTypes.MIN_ITEMS, function (_ref4) {
  var threshold = _ref4.threshold,
    rest = _objectWithoutProperties(_ref4, _excluded4);
  return length(_objectSpread({
    minimum: threshold,
    message: "Must have at least ".concat(threshold, " items.")
  }, rest));
}), validatorTypes.PATTERN, pattern), validatorTypes.MAX_NUMBER_VALUE, function (_ref5) {
  var value = _ref5.value,
    _ref5$includeThreshol = _ref5.includeThreshold,
    includeThreshold = _ref5$includeThreshol === void 0 ? true : _ref5$includeThreshol,
    rest = _objectWithoutProperties(_ref5, _excluded5);
  return numericality(_objectSpread(_defineProperty({}, includeThreshold ? '<=' : '<', value), rest));
}), validatorTypes.MIN_NUMBER_VALUE, function (_ref6) {
  var value = _ref6.value,
    _ref6$includeThreshol = _ref6.includeThreshold,
    includeThreshold = _ref6$includeThreshol === void 0 ? true : _ref6$includeThreshol,
    rest = _objectWithoutProperties(_ref6, _excluded6);
  return numericality(_objectSpread(_defineProperty({}, includeThreshold ? '>=' : '>', value), rest));
}), validatorTypes.URL, function (_ref7) {
  var message = _ref7.message,
    options = _objectWithoutProperties(_ref7, _excluded7);
  return pattern({
    pattern: url(options),
    message: message || 'String is not URL.'
  });
});
export default validatorMapper;