"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _react = _interopRequireWildcard(require("react"));
var _setWith = _interopRequireDefault(require("lodash/setWith"));
var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));
var _reactFinalForm = require("@hyperkid/react-final-form");
var _rendererContext = _interopRequireDefault(require("../renderer-context"));
var _condition = _interopRequireDefault(require("../condition"));
var _getConditionTriggers = _interopRequireDefault(require("../get-condition-triggers"));
var _prepareComponentProps = _interopRequireDefault(require("../prepare-component-props"));
var _excluded = ["component"],
  _excluded2 = ["condition", "hideField"];
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var FormFieldHideWrapper = function FormFieldHideWrapper(_ref) {
  var _ref$hideField = _ref.hideField,
    hideField = _ref$hideField === void 0 ? false : _ref$hideField,
    children = _ref.children;
  return hideField ? /*#__PURE__*/_react["default"].createElement("div", {
    hidden: true
  }, children) : children;
};
var ConditionTriggerWrapper = function ConditionTriggerWrapper(_ref2) {
  var condition = _ref2.condition,
    values = _ref2.values,
    children = _ref2.children,
    field = _ref2.field;
  return /*#__PURE__*/_react["default"].createElement(_condition["default"], {
    condition: condition,
    values: values,
    field: field
  }, children);
};
var _ConditionTriggerDetector = function ConditionTriggerDetector(_ref3) {
  var _ref3$values = _ref3.values,
    values = _ref3$values === void 0 ? {} : _ref3$values,
    _ref3$triggers = _ref3.triggers,
    triggers = _ref3$triggers === void 0 ? [] : _ref3$triggers,
    children = _ref3.children,
    condition = _ref3.condition,
    field = _ref3.field;
  var internalTriggers = (0, _toConsumableArray2["default"])(triggers);
  if (internalTriggers.length === 0) {
    return /*#__PURE__*/_react["default"].createElement(ConditionTriggerWrapper, {
      condition: condition,
      values: values,
      field: field
    }, children);
  }
  var name = internalTriggers.shift();
  return /*#__PURE__*/_react["default"].createElement(_reactFinalForm.Field, {
    name: name,
    subscription: {
      value: true,
      initial: true
    }
  }, function (_ref4) {
    var value = _ref4.input.value;
    return /*#__PURE__*/_react["default"].createElement(_ConditionTriggerDetector, {
      triggers: (0, _toConsumableArray2["default"])(internalTriggers),
      values: (0, _setWith["default"])((0, _cloneDeep["default"])(values), name, value, Object),
      condition: condition,
      field: field
    }, children);
  });
};
var FormConditionWrapper = function FormConditionWrapper(_ref5) {
  var condition = _ref5.condition,
    children = _ref5.children,
    field = _ref5.field,
    conditionMapper = _ref5.conditionMapper;
  if (condition) {
    var triggers = (0, _getConditionTriggers["default"])(condition, field, conditionMapper);
    return /*#__PURE__*/_react["default"].createElement(_ConditionTriggerDetector, {
      triggers: triggers,
      condition: condition,
      field: field
    }, children);
  }
  return children;
};
var SingleField = function SingleField(_ref6) {
  var component = _ref6.component,
    rest = (0, _objectWithoutProperties2["default"])(_ref6, _excluded);
  var _useContext = (0, _react.useContext)(_rendererContext["default"]),
    actionMapper = _useContext.actionMapper,
    componentMapper = _useContext.componentMapper,
    conditionMapper = _useContext.conditionMapper;
  var _prepareComponentProp = (0, _prepareComponentProps["default"])({
      component: component,
      rest: rest,
      componentMapper: componentMapper,
      actionMapper: actionMapper
    }),
    componentProps = _prepareComponentProp.componentProps,
    Component = _prepareComponentProp.Component,
    overrideProps = _prepareComponentProp.overrideProps,
    mergedResolveProps = _prepareComponentProp.mergedResolveProps;
  var _componentProps$overr = _objectSpread(_objectSpread(_objectSpread({}, componentProps), overrideProps), mergedResolveProps && {
      resolveProps: mergedResolveProps
    }),
    condition = _componentProps$overr.condition,
    hideField = _componentProps$overr.hideField,
    restProps = (0, _objectWithoutProperties2["default"])(_componentProps$overr, _excluded2);
  return /*#__PURE__*/_react["default"].createElement(FormConditionWrapper, {
    condition: condition,
    field: restProps,
    conditionMapper: conditionMapper
  }, /*#__PURE__*/_react["default"].createElement(FormFieldHideWrapper, {
    hideField: hideField
  }, /*#__PURE__*/_react["default"].createElement(Component, restProps)));
};
var _renderForm = function renderForm(fields) {
  return fields.map(function (field) {
    return Array.isArray(field) ? _renderForm(field) : /*#__PURE__*/_react["default"].createElement(SingleField, (0, _extends2["default"])({
      key: field.name
    }, field));
  });
};
var _default = exports["default"] = _renderForm;