"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _excluded = ["when"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var mergeFunctionTrigger = function mergeFunctionTrigger(fn, field) {
  var internalTriggers = [];
  var internalWhen = fn(field);
  if (Array.isArray(internalWhen)) {
    internalTriggers = (0, _toConsumableArray2["default"])(internalWhen);
  } else {
    internalTriggers.push(internalWhen);
  }
  return internalTriggers;
};
var _getConditionTriggers = function getConditionTriggers(condition, field) {
  var conditionMapper = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var triggers = [];
  if (Array.isArray(condition)) {
    return condition.reduce(function (acc, item) {
      return [].concat((0, _toConsumableArray2["default"])(acc), (0, _toConsumableArray2["default"])(_getConditionTriggers(item, field, conditionMapper)));
    }, []);
  }

  // extract mapped attributes to a new static condition object
  if ((0, _typeof2["default"])(condition.mappedAttributes) === 'object') {
    try {
      var newCondition = _objectSpread(_objectSpread({}, condition), {}, {
        mappedAttributes: undefined
      });
      Object.entries(condition.mappedAttributes).forEach(function (_ref) {
        var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
          attribute = _ref2[0],
          _ref2$ = (0, _toArray2["default"])(_ref2[1]),
          functionName = _ref2$[0],
          args = _ref2$.slice(1);
        if (!conditionMapper[functionName]) {
          throw new Error("Missing condition mapper function \"".concat(functionName, "\" for field ").concat(field.name, "!"));
        }
        newCondition[attribute] = conditionMapper[functionName].apply(conditionMapper, (0, _toConsumableArray2["default"])(args));
      });
      return _getConditionTriggers(newCondition, field, conditionMapper);
    } catch (error) {
      console.error(error.toString());
    }
  }
  var when = condition.when,
    rest = (0, _objectWithoutProperties2["default"])(condition, _excluded);
  var nestedKeys = ['and', 'or', 'sequence'];
  if (typeof when === 'string') {
    triggers = [].concat((0, _toConsumableArray2["default"])(triggers), [when]);
  }
  if (typeof when === 'function') {
    triggers = [].concat((0, _toConsumableArray2["default"])(triggers), (0, _toConsumableArray2["default"])(mergeFunctionTrigger(when, field)));
  }
  if (Array.isArray(when)) {
    when.forEach(function (item) {
      if (typeof item === 'string') {
        triggers = [].concat((0, _toConsumableArray2["default"])(triggers), [item]);
      }
      if (typeof item === 'function') {
        triggers = [].concat((0, _toConsumableArray2["default"])(triggers), (0, _toConsumableArray2["default"])(mergeFunctionTrigger(item, field)));
      }
    });
  }
  nestedKeys.forEach(function (key) {
    if (typeof rest[key] !== 'undefined') {
      rest[key].forEach(function (item) {
        triggers = [].concat((0, _toConsumableArray2["default"])(triggers), (0, _toConsumableArray2["default"])(_getConditionTriggers(item, field, conditionMapper)));
      });
    }
  });
  if ((0, _typeof2["default"])(condition.not) === 'object') {
    triggers = [].concat((0, _toConsumableArray2["default"])(triggers), (0, _toConsumableArray2["default"])(_getConditionTriggers(condition.not, field, conditionMapper)));
  }
  return Array.from(new Set(triggers));
};
var _default = exports["default"] = _getConditionTriggers;