"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prepareValidator = exports.prepareArrayValidator = exports.getValidate = exports.convertToWarning = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _helpers = require("../common/helpers");
var _validatorFunctions = require("../validators/validator-functions");
var _composeValidators = _interopRequireDefault(require("../compose-validators"));
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var convertToWarning = exports.convertToWarning = function convertToWarning(validator) {
  return function () {
    return {
      type: 'warning',
      error: validator.apply(void 0, arguments)
    };
  };
};
var prepareValidator = exports.prepareValidator = function prepareValidator(validator, mapper) {
  if (typeof validator === 'function') {
    return (0, _helpers.memoize)(validator);
  }
  if (validator.warning) {
    return convertToWarning(mapper[validator.type](_objectSpread({}, validator)));
  }
  return mapper[validator.type](_objectSpread({}, validator));
};
var getValidate = exports.getValidate = function getValidate(validate, dataType) {
  var mapper = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return [].concat((0, _toConsumableArray2["default"])(validate ? validate.map(function (validator) {
    return prepareValidator(validator, mapper);
  }) : []), (0, _toConsumableArray2["default"])(dataType ? [(0, _validatorFunctions.dataTypeValidator)(dataType)()] : []));
};
var prepareArrayValidator = exports.prepareArrayValidator = function prepareArrayValidator(validation) {
  return function () {
    var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    if (!Array.isArray(value)) {
      return;
    }
    var arrayValidator = (0, _composeValidators["default"])(validation);
    var result = arrayValidator(value && value.length > 0 ? value : undefined);
    if (typeof result === 'function') {
      result = result(value);
    }
    return result;
  };
};