"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _get = _interopRequireDefault(require("lodash/get"));
var _composeValidators = _interopRequireDefault(require("../compose-validators"));
var _defaultSchemaValidator = _interopRequireDefault(require("../default-schema-validator"));
var _getValidates = _interopRequireDefault(require("../get-validates"));
var _getVisibleFields = _interopRequireDefault(require("../get-visible-fields"));
var _validatorMapper = _interopRequireDefault(require("../validator-mapper"));
var _validatorHelpers = require("../use-field-api/validator-helpers");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var DEFAULT_COMPONENT = 'default-component';
var noop = function noop() {};
var _changeToDefaultComponent = function changeToDefaultComponent(schema) {
  if (Array.isArray(schema)) {
    return schema.map(_changeToDefaultComponent);
  }
  return _objectSpread(_objectSpread(_objectSpread({}, schema), schema.component && {
    component: DEFAULT_COMPONENT
  }), schema.fields && {
    fields: _changeToDefaultComponent(schema.fields)
  });
};
var validation = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee2(schema, options) {
    var values, componentMapper, validatorMapper, actionMapper, schemaValidatorMapper, omitWarnings, conditionMapper, validatorMapperMerged, validatorTypes, actionTypes, finalComponentMapper, finalSchema, validates;
    return _regenerator["default"].wrap(function (_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          if (schema) {
            _context2.next = 1;
            break;
          }
          throw new Error('validation requires a schema as the first argument.');
        case 1:
          if (!((0, _typeof2["default"])(options) !== 'object')) {
            _context2.next = 2;
            break;
          }
          throw new Error("options argument has to be type of object, provided: ".concat((0, _typeof2["default"])(options)));
        case 2:
          values = options.values, componentMapper = options.componentMapper, validatorMapper = options.validatorMapper, actionMapper = options.actionMapper, schemaValidatorMapper = options.schemaValidatorMapper, omitWarnings = options.omitWarnings, conditionMapper = options.conditionMapper;
          validatorMapperMerged = _objectSpread(_objectSpread({}, _validatorMapper["default"]), validatorMapper);
          validatorTypes = Object.keys(validatorMapperMerged);
          actionTypes = Object.keys(actionMapper || {});
          finalComponentMapper = componentMapper;
          finalSchema = schema;
          if (!finalComponentMapper) {
            finalComponentMapper = (0, _defineProperty2["default"])({}, DEFAULT_COMPONENT, noop);
            finalSchema = _changeToDefaultComponent(schema);
          }
          (0, _defaultSchemaValidator["default"])(finalSchema, finalComponentMapper, validatorTypes, actionTypes, schemaValidatorMapper);
          finalSchema = (0, _getVisibleFields["default"])(finalSchema, values, undefined, conditionMapper);
          validates = (0, _getValidates["default"])(finalSchema, {
            componentMapper: finalComponentMapper,
            actionMapper: actionMapper,
            values: values
          });
          _context2.next = 3;
          return Object.keys(validates).reduce(/*#__PURE__*/function () {
            var _ref2 = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee(accP, name) {
              var acc, error, index, validateFn, fieldError;
              return _regenerator["default"].wrap(function (_context) {
                while (1) switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 1;
                    return accP;
                  case 1:
                    acc = _context.sent;
                    index = 0;
                  case 2:
                    if (!(!error && index + 1 <= validates[name].length)) {
                      _context.next = 4;
                      break;
                    }
                    validateFn = (0, _composeValidators["default"])((0, _validatorHelpers.getValidate)(validates[name][index], undefined, validatorMapperMerged));
                    _context.next = 3;
                    return validateFn((0, _get["default"])(values, name), values, {});
                  case 3:
                    fieldError = _context.sent;
                    if ((fieldError === null || fieldError === void 0 ? void 0 : fieldError.type) !== 'warning' || (fieldError === null || fieldError === void 0 ? void 0 : fieldError.type) === 'warning' && !omitWarnings) {
                      error = fieldError;
                    }
                    index = index + 1;
                    _context.next = 2;
                    break;
                  case 4:
                    if (!error) {
                      _context.next = 5;
                      break;
                    }
                    return _context.abrupt("return", _objectSpread(_objectSpread({}, acc), {}, (0, _defineProperty2["default"])({}, name, error)));
                  case 5:
                    return _context.abrupt("return", acc);
                  case 6:
                  case "end":
                    return _context.stop();
                }
              }, _callee);
            }));
            return function (_x3, _x4) {
              return _ref2.apply(this, arguments);
            };
          }(), {});
        case 3:
          return _context2.abrupt("return", _context2.sent);
        case 4:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return function validation(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();
var _default = exports["default"] = validation;