"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _validatorFunctions = require("../validators/validator-functions");
var _urlValidator = _interopRequireDefault(require("../validators/url-validator"));
var _validatorTypes = _interopRequireDefault(require("../validator-types"));
var _excluded = ["threshold"],
  _excluded2 = ["threshold"],
  _excluded3 = ["threshold"],
  _excluded4 = ["threshold"],
  _excluded5 = ["value", "includeThreshold"],
  _excluded6 = ["value", "includeThreshold"],
  _excluded7 = ["message"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var validatorMapper = (0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])({}, _validatorTypes["default"].REQUIRED, _validatorFunctions.required), _validatorTypes["default"].MIN_LENGTH, function (_ref) {
  var threshold = _ref.threshold,
    rest = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return (0, _validatorFunctions.length)(_objectSpread({
    minimum: threshold
  }, rest));
}), _validatorTypes["default"].MAX_LENGTH, function (_ref2) {
  var threshold = _ref2.threshold,
    rest = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);
  return (0, _validatorFunctions.length)(_objectSpread({
    maximum: threshold
  }, rest));
}), _validatorTypes["default"].EXACT_LENGTH, function (_ref3) {
  var threshold = _ref3.threshold,
    rest = (0, _objectWithoutProperties2["default"])(_ref3, _excluded3);
  return (0, _validatorFunctions.length)(_objectSpread({
    is: threshold
  }, rest));
}), _validatorTypes["default"].MIN_ITEMS, function (_ref4) {
  var threshold = _ref4.threshold,
    rest = (0, _objectWithoutProperties2["default"])(_ref4, _excluded4);
  return (0, _validatorFunctions.length)(_objectSpread({
    minimum: threshold,
    message: "Must have at least ".concat(threshold, " items.")
  }, rest));
}), _validatorTypes["default"].PATTERN, _validatorFunctions.pattern), _validatorTypes["default"].MAX_NUMBER_VALUE, function (_ref5) {
  var value = _ref5.value,
    _ref5$includeThreshol = _ref5.includeThreshold,
    includeThreshold = _ref5$includeThreshol === void 0 ? true : _ref5$includeThreshol,
    rest = (0, _objectWithoutProperties2["default"])(_ref5, _excluded5);
  return (0, _validatorFunctions.numericality)(_objectSpread((0, _defineProperty2["default"])({}, includeThreshold ? '<=' : '<', value), rest));
}), _validatorTypes["default"].MIN_NUMBER_VALUE, function (_ref6) {
  var value = _ref6.value,
    _ref6$includeThreshol = _ref6.includeThreshold,
    includeThreshold = _ref6$includeThreshol === void 0 ? true : _ref6$includeThreshol,
    rest = (0, _objectWithoutProperties2["default"])(_ref6, _excluded6);
  return (0, _validatorFunctions.numericality)(_objectSpread((0, _defineProperty2["default"])({}, includeThreshold ? '>=' : '>', value), rest));
}), _validatorTypes["default"].URL, function (_ref7) {
  var message = _ref7.message,
    options = (0, _objectWithoutProperties2["default"])(_ref7, _excluded7);
  return (0, _validatorFunctions.pattern)({
    pattern: (0, _urlValidator["default"])(options),
    message: message || 'String is not URL.'
  });
});
var _default = exports["default"] = validatorMapper;